Package org.zkoss.zhtml

## Class Input

- java.lang.Object
- - org.zkoss.zk.ui.AbstractComponent
  - - org.zkoss.zhtml.impl.AbstractTag
    - - org.zkoss.zhtml.Input

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Cloneable`, `Component`, `DynamicPropertied`, `RawId`, `Scope`, `ComponentCtrl`
  Direct Known Subclasses:
    `Textarea`

      public class Input
      extends AbstractTag

  The input tag.
  Author:
    tomyeh
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.zkoss.zhtml.impl.AbstractTag

      `AbstractTag.ExtraCtrl`

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.AbstractComponent

      `AbstractComponent.Children, AbstractComponent.ForwardInfo, AbstractComponent.TargetInfo`

  - ### Field Summary

    - ### Fields inherited from class org.zkoss.zhtml.impl.AbstractTag

      `_tagnm`

    - ### Fields inherited from interface org.zkoss.zk.ui.Component

      `APPLICATION_SCOPE, COMPONENT_SCOPE, DESKTOP_SCOPE, PAGE_SCOPE, REQUEST_SCOPE, SESSION_SCOPE, SPACE_SCOPE`

    - ### Fields inherited from interface org.zkoss.zk.ui.sys.ComponentCtrl

      `AFTER_CHILD_ADDED, AFTER_CHILD_REMOVED, AFTER_CLONED, AFTER_PAGE_ATTACHED, AFTER_PAGE_DETACHED, AFTER_PARENT_CHANGED, CE_BUSY_IGNORE, CE_DUPLICATE_IGNORE, CE_IMPORTANT, CE_NON_DEFERRABLE, CE_REPEAT_IGNORE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `` | `Input()` |
    `protected` | `Input​(java.lang.String tagnm)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getAccept()` | Returns the accept of this input tag.
    `java.lang.String` | `getAlt()` | Returns the alt of this input tag.
    `java.lang.String` | `getAutocomplete()` | Returns the autocomplete of this input tag.
    `java.lang.String` | `getCapture()` | Returns the capture of this tag.
    `java.lang.String` | `getDirname()` | Returns the dirname of this input tag.
    `java.lang.String` | `getForm()` | Returns the form of this tag.
    `java.lang.String` | `getFormaction()` | Returns the formaction of this tag.
    `java.lang.String` | `getFormenctype()` | Returns the formenctype of this tag.
    `java.lang.String` | `getFormmethod()` | Returns the formmethod of this tag.
    `java.lang.String` | `getFormnovalidate()` | Returns the formnovalidate of this tag.
    `java.lang.String` | `getFormtarget()` | Returns the formtarget of this tag.
    `java.lang.String` | `getHeight()` | Returns the height of this input tag.
    `java.lang.String` | `getInputmode()` | Returns the inputmode of this input tag.
    `java.lang.String` | `getList()` | Returns the list of this input tag.
    `java.lang.String` | `getMax()` | Returns the max of this input tag.
    `java.lang.Integer` | `getMaxlength()` | Returns the maxlength of this input tag.
    `java.lang.String` | `getMin()` | Returns the min of this input tag.
    `java.lang.Integer` | `getMinlength()` | Returns the minlength of this tag.
    `java.lang.String` | `getName()` | Returns the name of this input tag.
    `java.lang.String` | `getPattern()` | Returns the pattern of this input tag.
    `java.lang.String` | `getPlaceholder()` | Returns the placeholder of this input tag.
    `java.lang.String` | `getSelectiondirection()` | Returns the selectiondirection of this input tag.
    `java.lang.Integer` | `getSize()` | Returns the size of this input tag.
    `java.lang.String` | `getSrc()` | Returns the src of this input tag.
    `java.lang.Integer` | `getStep()` | Returns the step of this input tag.
    `java.lang.String` | `getType()` | Returns the type of this input tag.
    `java.lang.String` | `getValue()` | Returns the value of this input.
    `java.lang.String` | `getWidgetClass()` | Returns the widget class, "zhtml.Input".
    `java.lang.String` | `getWidth()` | Returns the width of this input tag.
    `boolean` | `isAutofocus()` | Returns the autofocus of this input tag.
    `boolean` | `isChecked()` | Returns if the input is checked (type: checkbox or radio).
    `boolean` | `isDisabled()` | Returns the disabled of this input tag.
    `boolean` | `isMultiple()` | Returns the multiple of this input tag.
    `boolean` | `isReadonly()` | Returns the readonly of this input tag.
    `boolean` | `isRequired()` | Returns the required of this input tag.
    `void` | `service​(AuRequest request, boolean everError)` | Processes an AU request.
    `void` | `setAccept​(java.lang.String accept)` | Sets the accept of this input tag
    `void` | `setAlt​(java.lang.String alt)` | Sets the alt of this input tag
    `void` | `setAutocomplete​(java.lang.String autocomplete)` | Sets the autocomplete of this input tag
    `void` | `setAutofocus​(boolean autofocus)` | Sets the autofocus of this input tag.
    `void` | `setCapture​(java.lang.String capture)` | Sets the capture of this tag.
    `void` | `setChecked​(boolean checked)` | Sets if the input is checked (type: checkbox or radio).
    `void` | `setDirname​(java.lang.String dirname)` | Sets the dirname of this input tag
    `void` | `setDisabled​(boolean disabled)` | Sets the disabled of this input tag.
    `void` | `setForm​(java.lang.String form)` | Sets the form of this tag.
    `void` | `setFormaction​(java.lang.String formaction)` | Sets the formaction of this tag.
    `void` | `setFormenctype​(java.lang.String formenctype)` | Set the formenctype of this tag.
    `void` | `setFormmethod​(java.lang.String formmethod)` | Sets the formmethod of this tag.
    `void` | `setFormnovalidate​(java.lang.String formnovalidate)` | Sets the formnovalidate of this tag.
    `void` | `setFormtarget​(java.lang.String formtarget)` | Sets the formtarget of this tag.
    `void` | `setHeight​(java.lang.String height)` | Sets the height of this input tag
    `void` | `setInputmode​(java.lang.String inputmode)` | Sets the inputmode of this input tag
    `void` | `setList​(java.lang.String list)` | Sets the list of this input tag
    `void` | `setMax​(java.lang.String max)` | Sets the max of this input tag
    `void` | `setMaxlength​(java.lang.Integer maxlength)` | Sets the maxlength of this input tag
    `void` | `setMin​(java.lang.String min)` | Sets the min of this input tag
    `void` | `setMinlength​(java.lang.Integer minlength)` | Sets the minlength of this tag.
    `void` | `setMultiple​(boolean multiple)` | Sets the multiple of this input tag
    `void` | `setName​(java.lang.String name)` | Sets the name of this input tag
    `void` | `setPattern​(java.lang.String pattern)` | Sets the pattern of this input tag
    `void` | `setPlaceholder​(java.lang.String placeholder)` | Sets the placeholder of this input tag
    `void` | `setReadonly​(java.lang.Boolean readonly)` | Sets the readonly of this input tag
    `void` | `setRequired​(boolean required)` | Sets the required of this input tag
    `void` | `setSelectiondirection​(java.lang.String selectiondirection)` | Sets the selectiondirection of this input tag
    `void` | `setSize​(java.lang.Integer size)` | Sets the size of this input tag
    `void` | `setSrc​(java.lang.String src)` | Sets the src of this input tag
    `void` | `setStep​(java.lang.Integer step)` | Sets the step of this input tag
    `void` | `setType​(java.lang.String type)` | Sets the type of this input tag
    `void` | `setValue​(java.lang.String value)` | Sets the vallue of this input.
    `void` | `setWidth​(java.lang.String width)` | Sets the width of this input tag
    `protected void` | `smartUpdate​(java.lang.String attr, java.lang.Object value)` | Smart-updates a property of the peer widget associated with the component, running at the client, with the given value.

    - ### Methods inherited from class org.zkoss.zhtml.impl.AbstractTag

      `clone, getAccesskey, getDir, getDynamicProperties, getDynamicProperty, getExtraCtrl, getLang, getPropertyAccess, getSclass, getStyle, getTabindex, getTag, getTitle, hasDynamicProperty, isChildable, isContenteditable, isDraggable, isHidden, isOrphanTag, isSpellcheck, redraw, redrawChildrenDirectly, renderProperties, setAccesskey, setContenteditable, setDir, setDraggable, setDynamicProperty, setHidden, setLang, setSclass, setSpellcheck, setStyle, setTabindex, setTitle, setVisible, shallHideId, toString`

    - ### Methods inherited from class org.zkoss.zk.ui.AbstractComponent

      `addAnnotation, addCallback, addClientEvent, addEventHandler, addEventListener, addEventListener, addForward, addForward, addForward, addForward, addMoved, addRedrawCallback, addScopeListener, addShadowRoot, addShadowRootBefore, addSharedEventHandlerMap, appendChild, applyProperties, beforeChildAdded, beforeChildRemoved, beforeParentChanged, destroyIndexCacheMap, detach, didActivate, didActivate, didDeserialize, didDeserialize, disableBindingAnnotation, disableClientUpdate, disableHostChanged, enableBindingAnnotation, enableHostChanged, getAnnotatedProperties, getAnnotatedPropertiesBy, getAnnotation, getAnnotations, getAnnotations, getAttribute, getAttribute, getAttribute, getAttributeOrFellow, getAttributes, getAttributes, getAuService, getAutag, getCallback, getChildren, getClientAttribute, getClientDataAttribute, getClientEvents, getDefaultMold, getDefinition, getDesktop, getEventHandler, getEventHandlerNames, getEventListenerMap, getEventListeners, getFellow, getFellow, getFellowIfAny, getFellowIfAny, getFellows, getFirstChild, getForwards, getId, getIndexCacheMap, getLastChild, getMold, getNextSibling, getPage, getParent, getPreviousSibling, getRedrawCallback, getRoot, getShadowFellowIfAny, getShadowRoots, getShadowVariable, getShadowVariable, getShadowVariable0, getSpaceOwner, getSpecialRendererOutput, getStubonly, getSubBindingAnnotationCount, getTemplate, getTemplateNames, getUuid, getWidgetAttributeNames, getWidgetListener, getWidgetListenerNames, getWidgetOverride, getWidgetOverrideNames, hasAttribute, hasAttribute, hasAttribute, hasAttributeOrFellow, hasBindingAnnotation, hasFellow, hasFellow, hasSubBindingAnnotation, initIndexCacheMap, insertBefore, invalidate, isDisabledHostChanged, isInitialized, isInvalidated, isListenerAvailable, isVisible, onChildAdded, onChildRemoved, onPageAttached, onPageDetached, onParentChanged, onWrongValue, query, queryAll, redrawChildren, removeAttribute, removeAttribute, removeAttribute, removeCallback, removeChild, removeEventListener, removeForward, removeForward, removeRedrawCallback, removeScopeListener, removeShadowRoot, render, render, render, renderPropertiesOnly, replace, response, response, response, service, sessionDidActivate, sessionWillPassivate, setAttribute, setAttribute, setAttribute, setAuService, setAutag, setClientAttribute, setClientDataAttribute, setDefinition, setDefinition, setId, setMold, setPage, setPageBefore, setParent, setStubonly, setStubonly, setSubBindingAnnotationCount, setTemplate, setVisibleDirectly, setWidgetClass, setWidgetListener, setWidgetOverride, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdateWidgetListener, smartUpdateWidgetOverride, updateByClient, updateSubBindingAnnotationCount, willPassivate, willPassivate, willSerialize, willSerialize`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Input

          public Input()

    - #### Input

          protected Input​(java.lang.String tagnm)

  - ### Method Detail

    - #### getValue

          public java.lang.String getValue()

      Returns the value of this input.

    - #### setValue

          public void setValue​(java.lang.String value)
                        throws WrongValueException

      Sets the vallue of this input.
      Throws:
        `WrongValueException`

    - #### isChecked

          public boolean isChecked()

      Returns if the input is checked (type: checkbox or radio).

    - #### setChecked

          public void setChecked​(boolean checked)
                          throws WrongValueException

      Sets if the input is checked (type: checkbox or radio).
      Throws:
        `WrongValueException`

    - #### getAccept

          public java.lang.String getAccept()

      Returns the accept of this input tag.
      Since:
        8.0.3

    - #### setAccept

          public void setAccept​(java.lang.String accept)
                         throws WrongValueException

      Sets the accept of this input tag
      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getAlt

          public java.lang.String getAlt()

      Returns the alt of this input tag.
      Since:
        8.0.3

    - #### setAlt

          public void setAlt​(java.lang.String alt)
                      throws WrongValueException

      Sets the alt of this input tag
      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getAutocomplete

          public java.lang.String getAutocomplete()

      Returns the autocomplete of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setAutocomplete

          public void setAutocomplete​(java.lang.String autocomplete)
                               throws WrongValueException

      Sets the autocomplete of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### isAutofocus

          public boolean isAutofocus()

      Returns the autofocus of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setAutofocus

          public void setAutofocus​(boolean autofocus)
                            throws WrongValueException

      Sets the autofocus of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getDirname

          public java.lang.String getDirname()

      Returns the dirname of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setDirname

          public void setDirname​(java.lang.String dirname)
                          throws WrongValueException

      Sets the dirname of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### isDisabled

          public boolean isDisabled()

      Returns the disabled of this input tag.
      Since:
        8.0.3

    - #### setDisabled

          public void setDisabled​(boolean disabled)
                           throws WrongValueException

      Sets the disabled of this input tag.
      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getHeight

          public java.lang.String getHeight()

      Returns the height of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setHeight

          public void setHeight​(java.lang.String height)
                         throws WrongValueException

      Sets the height of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getInputmode

          public java.lang.String getInputmode()

      Returns the inputmode of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setInputmode

          public void setInputmode​(java.lang.String inputmode)
                            throws WrongValueException

      Sets the inputmode of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getList

          public java.lang.String getList()

      Returns the list of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setList

          public void setList​(java.lang.String list)
                       throws WrongValueException

      Sets the list of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getMax

          public java.lang.String getMax()

      Returns the max of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setMax

          public void setMax​(java.lang.String max)
                      throws WrongValueException

      Sets the max of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getMaxlength

          public java.lang.Integer getMaxlength()

      Returns the maxlength of this input tag.
      Since:
        8.0.3

    - #### setMaxlength

          public void setMaxlength​(java.lang.Integer maxlength)
                            throws WrongValueException

      Sets the maxlength of this input tag
      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getMin

          public java.lang.String getMin()

      Returns the min of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setMin

          public void setMin​(java.lang.String min)
                      throws WrongValueException

      Sets the min of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getMinlength

          public java.lang.Integer getMinlength()

      Returns the minlength of this tag.
      Since:
        10.0.0

    - #### setMinlength

          public void setMinlength​(java.lang.Integer minlength)
                            throws WrongValueException

      Sets the minlength of this tag.
      Throws:
        `WrongValueException`
      Since:
        10.0.0

    - #### isMultiple

          public boolean isMultiple()

      Returns the multiple of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setMultiple

          public void setMultiple​(boolean multiple)
                           throws WrongValueException

      Sets the multiple of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getName

          public java.lang.String getName()

      Returns the name of this input tag.
      Since:
        8.0.3

    - #### setName

          public void setName​(java.lang.String name)
                       throws WrongValueException

      Sets the name of this input tag
      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getPattern

          public java.lang.String getPattern()

      Returns the pattern of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setPattern

          public void setPattern​(java.lang.String pattern)
                          throws WrongValueException

      Sets the pattern of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getPlaceholder

          public java.lang.String getPlaceholder()

      Returns the placeholder of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setPlaceholder

          public void setPlaceholder​(java.lang.String placeholder)
                              throws WrongValueException

      Sets the placeholder of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### isReadonly

          public boolean isReadonly()

      Returns the readonly of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setReadonly

          public void setReadonly​(java.lang.Boolean readonly)
                           throws WrongValueException

      Sets the readonly of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### isRequired

          public boolean isRequired()

      Returns the required of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setRequired

          public void setRequired​(boolean required)
                           throws WrongValueException

      Sets the required of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getSelectiondirection

          public java.lang.String getSelectiondirection()

      Returns the selectiondirection of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setSelectiondirection

          public void setSelectiondirection​(java.lang.String selectiondirection)
                                     throws WrongValueException

      Sets the selectiondirection of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getSize

          public java.lang.Integer getSize()

      Returns the size of this input tag.
      Since:
        8.0.3

    - #### setSize

          public void setSize​(java.lang.Integer size)
                       throws WrongValueException

      Sets the size of this input tag
      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getSrc

          public java.lang.String getSrc()

      Returns the src of this input tag.
      Since:
        8.0.3

    - #### setSrc

          public void setSrc​(java.lang.String src)
                      throws WrongValueException

      Sets the src of this input tag
      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getStep

          public java.lang.Integer getStep()

      Returns the step of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setStep

          public void setStep​(java.lang.Integer step)
                       throws WrongValueException

      Sets the step of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getType

          public java.lang.String getType()

      Returns the type of this input tag.
      Since:
        8.0.3

    - #### setType

          public void setType​(java.lang.String type)
                       throws WrongValueException

      Sets the type of this input tag
      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getWidth

          public java.lang.String getWidth()

      Returns the width of this input tag.

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Since:
        8.0.3

    - #### setWidth

          public void setWidth​(java.lang.String width)
                        throws WrongValueException

      Sets the width of this input tag

      Notice that this attribute refers to the corresponding attribute of the HTML5 specification. Hence, it would still be rendered to client-side as a DOM attribute even if the browser doesn’t support it.

      Throws:
        `WrongValueException`
      Since:
        8.0.3

    - #### getCapture

          public java.lang.String getCapture()

      Returns the capture of this tag.
      Since:
        10.0.0

    - #### getForm

          public java.lang.String getForm()

      Returns the form of this tag.
      Since:
        10.0.0

    - #### setForm

          public void setForm​(java.lang.String form)
                       throws WrongValueException

      Sets the form of this tag.

      The <form> element to associate the button with (its form owner). The value of this attribute must be the id of a <form> in the same document. (If this attribute is not set, the <button> is associated with its ancestor <form> element, if any.)

      This attribute lets you associate <button> elements to <form>s anywhere in the document, not just inside a <form>. It can also override an ancestor <form> element.

      Throws:
        `WrongValueException`
      Since:
        10.0.0

    - #### getFormaction

          public java.lang.String getFormaction()

      Returns the formaction of this tag.
      Since:
        10.0.0

    - #### setFormaction

          public void setFormaction​(java.lang.String formaction)
                             throws WrongValueException

      Sets the formaction of this tag.

      The URL that processes the information submitted by the button. Overrides the `action` attribute of the button's form owner. Does nothing if there is no form owner.

      Throws:
        `WrongValueException`
      Since:
        10.0.0

    - #### getFormenctype

          public java.lang.String getFormenctype()

      Returns the formenctype of this tag.
      Since:
        10.0.0

    - #### setFormenctype

          public void setFormenctype​(java.lang.String formenctype)
                              throws WrongValueException

      Set the formenctype of this tag.

      If the button is a submit button (it's inside/associated with a <form> and doesn't have `type="button"`), specifies how to encode the form data that is submitted.

      Throws:
        `WrongValueException`
      Since:
        10.0.0

    - #### getFormmethod

          public java.lang.String getFormmethod()

      Returns the formmethod of this tag.
      Since:
        10.0.0

    - #### setFormmethod

          public void setFormmethod​(java.lang.String formmethod)
                             throws WrongValueException

      Sets the formmethod of this tag.

      If the button is a submit button (it's inside/associated with a <form> and doesn't have `type="button"`), this attribute specifies the HTTP method used to submit the form.

      Throws:
        `WrongValueException`
      Since:
        10.0.0

    - #### getFormnovalidate

          public java.lang.String getFormnovalidate()

      Returns the formnovalidate of this tag.
      Since:
        10.0.0

    - #### setFormnovalidate

          public void setFormnovalidate​(java.lang.String formnovalidate)
                                 throws WrongValueException

      Sets the formnovalidate of this tag.

      If the button is a submit button, this Boolean attribute specifies that the form is not to be validated when it is submitted. If this attribute is specified, it overrides the novalidate attribute of the button's form owner.

      Throws:
        `WrongValueException`
      Since:
        10.0.0

    - #### getFormtarget

          public java.lang.String getFormtarget()

      Returns the formtarget of this tag.
      Since:
        10.0.0

    - #### setFormtarget

          public void setFormtarget​(java.lang.String formtarget)
                             throws WrongValueException

      Sets the formtarget of this tag.

      If the button is a submit button, this attribute is an author-defined name or standardized, underscore-prefixed keyword indicating where to display the response from submitting the form. This is the name of, or keyword for, a browsing context (a tab, window, or <iframe>). If this attribute is specified, it overrides the target attribute of the button's form owner.

      Throws:
        `WrongValueException`
      Since:
        10.0.0

    - #### setCapture

          public void setCapture​(java.lang.String capture)
                          throws WrongValueException

      Sets the capture of this tag.
      Throws:
        `WrongValueException`
      Since:
        10.0.0

    - #### getWidgetClass

          public java.lang.String getWidgetClass()

      Returns the widget class, "zhtml.Input".
      Specified by:
        `getWidgetClass` in interface `Component`
      Overrides:
        `getWidgetClass` in class `AbstractTag`
      Since:
        8.0.0
      See Also:
        `Component.setWidgetClass(java.lang.String)`

    - #### smartUpdate

          protected void smartUpdate​(java.lang.String attr,
                                     java.lang.Object value)

      Description copied from class: `AbstractComponent`
      Smart-updates a property of the peer widget associated with the component, running at the client, with the given value.

      The second invocation with the same property will replace the previous call. In other words, the same property will be set only once in each execution. If you prefer to send both updates to the client, use `AbstractComponent.smartUpdate(String, Object, boolean)` instead.

      This method has no effect if `AbstractComponent.invalidate()` is ever invoked (in the same execution), since `AbstractComponent.invalidate()` assumes the whole content shall be redrawn and all smart updates to this components can be ignored,

      Once `AbstractComponent.invalidate()` is called, all invocations to `AbstractComponent.smartUpdate(String, Object)` will then be ignored, and `AbstractComponent.redraw(java.io.Writer)` will be invoked later.

      It can be called only in the request-processing and event-processing phases; excluding the redrawing phase.

      There are two ways to draw a component, one is to invoke `Component.invalidate()`, and the other is `AbstractComponent.smartUpdate(String, Object)`. While `Component.invalidate()` causes the whole content to redraw, `AbstractComponent.smartUpdate(String, Object)` let component developer control which part to redraw.

      Overrides:
        `smartUpdate` in class `AbstractComponent`
        `value` - the new value. If it is `DeferredValue`, the value will be retrieved (by calling `DeferredValue.getValue()`) in the rendering phase. It is useful if the value can not be determined now.

        For some old application servers (example, Websphere 5.1), `Execution.encodeURL(java.lang.String)` cannot be called in the event processing thread. So, the developers have to use `DeferredValue` or disable the use of the event processing thread (by use of `disable-event-thread` in zk.xml).

        If you want to generate the JavaScript code directly (i.e., the value is a valid JavaScript snippet), you can use `JavaScriptValue`. Notice that the JavaScript code will be evaluated before assigning it to the widget.

        If the value is a Date object, a special pattern will be generated (a.k.a., marshaling) to ensure it can be unmarshalled back correctly at the client. Notice that it is marshalled to a string based on `TimeZones.getCurrent()`, and then unmarshalled back at the client. In other words, if the client is in different time-zone, the value returned by getTime() might be different. However, the value will remain the same if the client marshalled the Date object back. In other words, it assumes the browser's time zone from enduser's perspective (not really browser's setting) shall be the same as `TimeZones.getCurrent()`.

        If the value is a component, a special pattern will be generated to ensure it can be unmarshalled back correctly at the client.

        In addition, the value can be any kind of objects that the client accepts (marshaled by JSON) (see also `JSONAware`).

      See Also:
        `AbstractComponent.updateByClient(java.lang.String, java.lang.Object)`, `AbstractComponent.smartUpdate(String, Object, boolean)`

    - #### service

          public void service​(AuRequest request,
                              boolean everError)

      Processes an AU request.
      Specified by:
        `service` in interface `ComponentCtrl`
      Overrides:
        `service` in class `AbstractComponent`
        `everError` - whether any error ever occurred before processing this request.
      Since:
        5.0.0
      See Also:
        `AbstractComponent.setAuService(org.zkoss.zk.au.AuService)`